error handling
[oweals/gnunet.git] / src / abd / test_abd_bi_bw_link2.sh
1 #!/usr/bin/env bash
2 trap "gnunet-arm -e -c test_abd_lookup.conf" SIGINT
3
4 LOCATION=$(which gnunet-config)
5 if [ -z $LOCATION ]
6 then
7   LOCATION="gnunet-config"
8 fi
9 $LOCATION --version 1> /dev/null
10 if test $? != 0
11 then
12         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
13         exit 77
14 fi
15
16 rm -rf `gnunet-config -c test_abd_lookup.conf -s PATHS -o GNUNET_HOME -f`
17
18
19
20
21 which timeout > /dev/null 2>&1 && DO_TIMEOUT="timeout 10"
22 gnunet-arm -s -c test_abd_lookup.conf
23
24 gnunet-identity -C a -c test_abd_lookup.conf
25 gnunet-identity -C b -c test_abd_lookup.conf
26 gnunet-identity -C c -c test_abd_lookup.conf
27 gnunet-identity -C d -c test_abd_lookup.conf
28 gnunet-identity -C e -c test_abd_lookup.conf
29 gnunet-identity -C f -c test_abd_lookup.conf
30 gnunet-identity -C g -c test_abd_lookup.conf
31 AKEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep a | awk '{print $3}')
32 BKEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep b | awk '{print $3}')
33 CKEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep c | awk '{print $3}')
34 DKEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep d | awk '{print $3}')
35 EKEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep e | awk '{print $3}')
36 FKEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep f | awk '{print $3}')
37 GKEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep g | awk '{print $3}')
38 gnunet-identity -d
39
40 #   (1) (A.a) <- B.b
41 #   (2) (B.b) <- G.g.c
42 #   (3) G.g <- (C)
43 #   (3) C.c <- (D.d)
44 #   (4) D.d <- (E.e)
45 #   (5) E.e <- (F)
46
47 # BIDIRECTIONAL
48 gnunet-abd --createIssuerSide --ego=a --attribute="a" --subject="$BKEY b" --ttl=5m -c test_abd_lookup.conf
49 gnunet-namestore -D -z a
50 gnunet-abd --createIssuerSide --ego=b --attribute="b" --subject="$GKEY g.c" --ttl=5m -c test_abd_lookup.conf
51 gnunet-namestore -D -z b
52
53 SIGNED=`$DO_TIMEOUT gnunet-abd --signSubjectSide --ego=g --attribute="g" --subject="$CKEY" --ttl="2019-12-12 10:00:00"`
54 gnunet-abd --createSubjectSide --ego=c --import="$SIGNED"
55 gnunet-namestore -D -z c
56 SIGNED=`$DO_TIMEOUT gnunet-abd --signSubjectSide --ego=c --attribute="c" --subject="$DKEY d" --ttl="2019-12-12 10:00:00"`
57 gnunet-abd --createSubjectSide --ego=d --import="$SIGNED"
58 gnunet-namestore -D -z d
59 SIGNED=`$DO_TIMEOUT gnunet-abd --signSubjectSide --ego=d --attribute="d" --subject="$EKEY e" --ttl="2019-12-12 10:00:00"`
60 gnunet-abd --createSubjectSide --ego=e --import="$SIGNED"
61 gnunet-namestore -D -z e
62 SIGNED=`$DO_TIMEOUT gnunet-abd --signSubjectSide --ego=e --attribute="e" --subject="$FKEY" --ttl="2019-12-12 10:00:00"`
63 gnunet-abd --createSubjectSide --ego=f --import="$SIGNED" --private
64 gnunet-namestore -D -z f
65
66 # Starting to resolve
67 echo "+++ Starting to Resolve +++"
68
69 DELS=`$DO_TIMEOUT gnunet-abd --collect --issuer=$AKEY --attribute="a" --ego=f --forward --backward -c test_abd_lookup.conf | paste -d, -s - -`
70 echo $DELS
71 echo gnunet-abd --verify --issuer=$AKEY --attribute="a" --subject=$FKEY --delegate=\'$DELS\' --forward --backward -c test_abd_lookup.conf
72 gnunet-abd --verify --issuer=$AKEY --attribute="a" --subject=$FKEY --delegate="$DELS" --forward --backward -c test_abd_lookup.conf
73
74 RES=$?
75
76 # Cleanup properly
77 gnunet-namestore -z a -d -n "a" -t ATTR -c test_abd_lookup.conf
78 gnunet-namestore -z b -d -n "b" -t ATTR -c test_abd_lookup.conf
79 gnunet-namestore -z c -d -n "@" -t DEL -c test_abd_lookup.conf
80 gnunet-namestore -z d -d -n "@" -t DEL -c test_abd_lookup.conf
81 gnunet-namestore -z e -d -n "@" -t DEL -c test_abd_lookup.conf
82 gnunet-namestore -z f -d -n "@" -t DEL -c test_abd_lookup.conf
83
84 gnunet-arm -e -c test_abd_lookup.conf
85
86 if [ "$RES" == 0 ]
87 then
88   exit 0
89 else
90   echo "FAIL: Failed to verify credential."
91   exit 1
92 fi
93